Index: LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90	(revision 1795)
+++ LMDZ5/branches/testing/libf/dyn3dmem/iniacademic_loc.F90	(revision 1795)
@@ -0,0 +1,308 @@
+!
+! $Id: iniacademic.F90 1625 2012-05-09 13:14:48Z lguez $
+!
+SUBROUTINE iniacademic_loc(vcov,ucov,teta,q,masse,ps,phis,time_0)
+
+  USE filtreg_mod
+  USE infotrac, ONLY : nqtot
+  USE control_mod, ONLY: day_step,planet_type
+  USE parallel
+#ifdef CPP_IOIPSL
+  USE IOIPSL
+#else
+  ! if not using IOIPSL, we still need to use (a local version of) getin
+  USE ioipsl_getincom
+#endif
+  USE Write_Field
+
+  !   Author:    Frederic Hourdin      original: 15/01/93
+  ! The forcing defined here is from Held and Suarez, 1994, Bulletin
+  ! of the American Meteorological Society, 75, 1825.
+
+  IMPLICIT NONE
+
+  !   Declararations:
+  !   ---------------
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comvert.h"
+  include "comconst.h"
+  include "comgeom.h"
+  include "academic.h"
+  include "ener.h"
+  include "temps.h"
+  include "iniprint.h"
+  include "logic.h"
+
+  !   Arguments:
+  !   ----------
+
+  real time_0
+
+  !   variables dynamiques
+  REAL vcov(ijb_v:ije_v,llm),ucov(ijb_u:ije_u,llm) ! vents covariants
+  REAL teta(ijb_u:ije_u,llm)                 ! temperature potentielle
+  REAL q(ijb_u:ije_u,llm,nqtot)               ! champs advectes
+  REAL ps(ijb_u:ije_u)                       ! pression  au sol
+  REAL masse(ijb_u:ije_u,llm)                ! masse d'air
+  REAL phis(ijb_u:ije_u)                     ! geopotentiel au sol
+
+  !   Local:
+  !   ------
+
+  REAL,ALLOCATABLE :: vcov_glo(:,:),ucov_glo(:,:),teta_glo(:,:)
+  REAL,ALLOCATABLE :: q_glo(:,:),masse_glo(:,:),ps_glo(:)
+  REAL,ALLOCATABLE :: phis_glo(:)
+  REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
+  REAL pks(ip1jmp1)                      ! exner au  sol
+  REAL pk(ip1jmp1,llm)                   ! exner au milieu des couches
+  REAL pkf(ip1jmp1,llm)                  ! exner filt.au milieu des couches
+  REAL phi(ip1jmp1,llm)                  ! geopotentiel
+  REAL ddsin,zsig,tetapv,w_pv  ! variables auxiliaires
+  real tetastrat ! potential temperature in the stratosphere, in K
+  real tetajl(jjp1,llm)
+  INTEGER i,j,l,lsup,ij
+
+  REAL teta0,ttp,delt_y,delt_z,eps ! Constantes pour profil de T
+  REAL k_f,k_c_a,k_c_s         ! Constantes de rappel
+  LOGICAL ok_geost             ! Initialisation vent geost. ou nul
+  LOGICAL ok_pv                ! Polar Vortex
+  REAL phi_pv,dphi_pv,gam_pv   ! Constantes pour polar vortex 
+
+  real zz,ran1
+  integer idum
+
+  REAL zdtvr
+  real,allocatable :: alpha(:,:),beta(:,:)
+  
+  character(len=*),parameter :: modname="iniacademic"
+  character(len=80) :: abort_message
+
+  !-----------------------------------------------------------------------
+  ! 1. Initializations for Earth-like case
+  ! --------------------------------------
+  !
+  ! initialize planet radius, rotation rate,...
+  call conf_planete
+
+  time_0=0.
+  day_ref=1
+  annee_ref=0
+
+  im         = iim
+  jm         = jjm
+  day_ini    = 1
+  dtvr    = daysec/REAL(day_step)
+  zdtvr=dtvr
+  etot0      = 0.
+  ptot0      = 0.
+  ztot0      = 0.
+  stot0      = 0.
+  ang0       = 0.
+
+  if (llm == 1) then
+     ! specific initializations for the shallow water case
+     kappa=1
+  endif
+
+  CALL iniconst
+  CALL inigeom
+  CALL inifilr
+
+  if (llm == 1) then
+     ! initialize fields for the shallow water case, if required
+     if (.not.read_start) then
+        phis(ijb_u:ije_u)=0.
+        q(ijb_u:ije_u,1:llm,1:nqtot)=0
+        CALL sw_case_williamson91_6_loc(vcov,ucov,teta,masse,ps)
+     endif
+  endif
+
+  academic_case: if (iflag_phys >= 2) then
+     ! initializations
+
+     ! 1. local parameters
+     ! by convention, winter is in the southern hemisphere
+     ! Geostrophic wind or no wind?
+     ok_geost=.TRUE.
+     CALL getin('ok_geost',ok_geost)
+     ! Constants for Newtonian relaxation and friction
+     k_f=1.                !friction 
+     CALL getin('k_j',k_f)
+     k_f=1./(daysec*k_f)
+     k_c_s=4.  !cooling surface
+     CALL getin('k_c_s',k_c_s)
+     k_c_s=1./(daysec*k_c_s)
+     k_c_a=40. !cooling free atm
+     CALL getin('k_c_a',k_c_a)
+     k_c_a=1./(daysec*k_c_a)
+     ! Constants for Teta equilibrium profile
+     teta0=315.     ! mean Teta (S.H. 315K)
+     CALL getin('teta0',teta0)
+     ttp=200.       ! Tropopause temperature (S.H. 200K)
+     CALL getin('ttp',ttp)
+     eps=0.         ! Deviation to N-S symmetry(~0-20K)
+     CALL getin('eps',eps)
+     delt_y=60.     ! Merid Temp. Gradient (S.H. 60K)
+     CALL getin('delt_y',delt_y)
+     delt_z=10.     ! Vertical Gradient (S.H. 10K)
+     CALL getin('delt_z',delt_z)
+     ! Polar vortex
+     ok_pv=.false.
+     CALL getin('ok_pv',ok_pv)
+     phi_pv=-50.            ! Latitude of edge of vortex
+     CALL getin('phi_pv',phi_pv)
+     phi_pv=phi_pv*pi/180.
+     dphi_pv=5.             ! Width of the edge
+     CALL getin('dphi_pv',dphi_pv)
+     dphi_pv=dphi_pv*pi/180.
+     gam_pv=4.              ! -dT/dz vortex (in K/km)
+     CALL getin('gam_pv',gam_pv)
+
+     ! 2. Initialize fields towards which to relax
+     ! Friction
+     knewt_g=k_c_a
+     DO l=1,llm
+        zsig=presnivs(l)/preff
+        knewt_t(l)=(k_c_s-k_c_a)*MAX(0.,(zsig-0.7)/0.3)
+        kfrict(l)=k_f*MAX(0.,(zsig-0.7)/0.3)
+     ENDDO
+     DO j=1,jjp1
+        clat4((j-1)*iip1+1:j*iip1)=cos(rlatu(j))**4
+     ENDDO
+
+     ! Potential temperature 
+     DO l=1,llm
+        zsig=presnivs(l)/preff
+        tetastrat=ttp*zsig**(-kappa)
+        tetapv=tetastrat
+        IF ((ok_pv).AND.(zsig.LT.0.1)) THEN
+           tetapv=tetastrat*(zsig*10.)**(kappa*cpp*gam_pv/1000./g)
+        ENDIF
+        DO j=1,jjp1
+           ! Troposphere
+           ddsin=sin(rlatu(j))
+           tetajl(j,l)=teta0-delt_y*ddsin*ddsin+eps*ddsin &
+                -delt_z*(1.-ddsin*ddsin)*log(zsig)
+           if (planet_type=="giant") then
+             tetajl(j,l)=teta0+(delt_y*                   &
+                ((sin(rlatu(j)*3.14159*eps+0.0001))**2)   &
+                / ((rlatu(j)*3.14159*eps+0.0001)**2))     &
+                -delt_z*log(zsig)
+           endif
+           ! Profil stratospherique isotherme (+vortex)
+           w_pv=(1.-tanh((rlatu(j)-phi_pv)/dphi_pv))/2.
+           tetastrat=tetastrat*(1.-w_pv)+tetapv*w_pv             
+           tetajl(j,l)=MAX(tetajl(j,l),tetastrat)  
+        ENDDO
+     ENDDO
+
+     !          CALL writefield('theta_eq',tetajl)
+
+     do l=1,llm
+        do j=1,jjp1
+           do i=1,iip1
+              ij=(j-1)*iip1+i
+              tetarappel(ij,l)=tetajl(j,l)
+           enddo
+        enddo
+     enddo
+
+     ! 3. Initialize fields (if necessary)
+     IF (.NOT. read_start) THEN
+       ! allocate global fields:
+!       allocate(vcov_glo(ip1jm,llm))
+       allocate(ucov_glo(ip1jmp1,llm))
+       allocate(teta_glo(ip1jmp1,llm))
+       allocate(ps_glo(ip1jmp1))
+       allocate(masse_glo(ip1jmp1,llm))
+       allocate(phis_glo(ip1jmp1))
+       allocate(alpha(ip1jmp1,llm))
+       allocate(beta(ip1jmp1,llm))
+
+        ! surface pressure
+        if (iflag_phys>2) then
+           ! specific value for CMIP5 aqua/terra planets
+           ! "Specify the initial dry mass to be equivalent to
+           !  a global mean surface pressure (101325 minus 245) Pa."
+           ps_glo(:)=101080.  
+        else
+           ! use reference surface pressure
+           ps_glo(:)=preff
+        endif
+        
+        ! ground geopotential
+        phis_glo(:)=0.
+
+        CALL pression ( ip1jmp1, ap, bp, ps_glo, p       )
+        if (pressure_exner) then
+          CALL exner_hyb( ip1jmp1, ps_glo, p,alpha,beta, pks, pk, pkf )
+        else
+          call exner_milieu(ip1jmp1,ps_glo,p,beta,pks,pk,pkf)
+        endif
+        CALL massdair(p,masse_glo)
+
+        ! bulk initialization of temperature
+        teta_glo(:,:)=tetarappel(:,:)
+
+        ! geopotential
+        CALL geopot(ip1jmp1,teta_glo,pk,pks,phis_glo,phi)
+
+        ! winds
+        if (ok_geost) then
+           call ugeostr(phi,ucov_glo)
+        else
+           ucov_glo(:,:)=0.
+        endif
+        vcov(ijb_v:ije_v,1:llm)=0.
+
+        ! bulk initialization of tracers
+        if (planet_type=="earth") then
+           ! Earth: first two tracers will be water
+           do i=1,nqtot
+              if (i == 1) q(ijb_u:ije_u,:,i)=1.e-10
+              if (i == 2) q(ijb_u:ije_u,:,i)=1.e-15
+              if (i.gt.2) q(ijb_u:ije_u,:,i)=0.
+           enddo
+        else
+           q(ijb_u:ije_u,:,:)=0
+        endif ! of if (planet_type=="earth")
+
+        ! add random perturbation to temperature
+        idum  = -1
+        zz = ran1(idum)
+        idum  = 0
+        do l=1,llm
+           do ij=iip2,ip1jm
+              teta_glo(ij,l)=teta_glo(ij,l)*(1.+0.005*ran1(idum))
+           enddo
+        enddo
+
+        ! maintain periodicity in longitude
+        do l=1,llm
+           do ij=1,ip1jmp1,iip1
+              teta_glo(ij+iim,l)=teta_glo(ij,l)
+           enddo
+        enddo
+
+        ! copy data from global array to local array:
+        teta(ijb_u:ije_u,:)=teta_glo(ijb_u:ije_u,:)
+        ucov(ijb_u:ije_u,:)=ucov_glo(ijb_u:ije_u,:)
+!        vcov(ijb_v:ije_v,:)=vcov_glo(ijb_v:ije_v,:)
+        masse(ijb_u:ije_u,:)=masse_glo(ijb_u:ije_u,:)
+        ps(ijb_u:ije_u)=ps_glo(ijb_u:ije_u)
+        phis(ijb_u:ije_u)=phis_glo(ijb_u:ije_u)
+
+        deallocate(teta_glo)
+        deallocate(ucov_glo)
+!        deallocate(vcov_glo)
+        deallocate(masse_glo)
+        deallocate(ps_glo)
+        deallocate(phis_glo)
+        deallocate(alpha)
+        deallocate(beta)
+     ENDIF ! of IF (.NOT. read_start)
+  endif academic_case
+
+END SUBROUTINE iniacademic_loc
Index: LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/leapfrog_loc.F	(revision 1795)
@@ -1125,30 +1125,5 @@
         ! Sponge layer (if any)
         IF (ok_strato) THEN
-          ! set dufi,dvfi,... to zero
-          ijb=ij_begin
-          ije=ij_end
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-          do l=1,llm
-            dufi(ijb:ije,l)=0
-            dtetafi(ijb:ije,l)=0
-            dqfi(ijb:ije,l,1:nqtot)=0
-          enddo
-!$OMP END DO
-!$OMP MASTER
-          dpfi(ijb:ije)=0
-!$OMP END MASTER
-          ijb=ij_begin
-          ije=ij_end
-          if (pole_sud) ije=ije-iip1
-!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-          do l=1,llm
-            dvfi(ijb:ije,l)=0
-          enddo
-!$OMP END DO
-
-          CALL top_bound_loc(vcov,ucov,teta,masse,dufi,dvfi,dtetafi)
-          CALL addfi_loc( dtvr, leapf, forward   ,
-     $                  ucov, vcov, teta , q   ,ps ,
-     $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
+          CALL top_bound_loc(vcov,ucov,teta,masse,dtvr)
 !$OMP BARRIER
         ENDIF ! of IF (ok_strato) 
Index: LMDZ5/branches/testing/libf/dyn3dmem/sw_case_williamson91_6_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/sw_case_williamson91_6_loc.F	(revision 1795)
+++ LMDZ5/branches/testing/libf/dyn3dmem/sw_case_williamson91_6_loc.F	(revision 1795)
@@ -0,0 +1,189 @@
+!
+! $Id $
+!
+      SUBROUTINE sw_case_williamson91_6_loc(vcov,ucov,teta,masse,ps)
+
+c=======================================================================
+c
+c   Author:    Thomas Dubos      original: 26/01/2010
+c   -------
+c
+c   Subject:
+c   ------
+c   Realise le cas-test 6 de Williamson et al. (1991) : onde de Rossby-Haurwitz
+c
+c   Method:
+c   --------
+c
+c   Interface:
+c   ----------
+c
+c      Input:
+c      ------
+c
+c      Output:
+c      -------
+c
+c=======================================================================
+      USE parallel
+
+      IMPLICIT NONE
+c-----------------------------------------------------------------------
+c   Declararations:
+c   ---------------
+
+#include "dimensions.h"
+#include "paramet.h"
+#include "comvert.h"
+#include "comconst.h"
+#include "comgeom.h"
+#include "iniprint.h"
+
+c   Arguments:
+c   ----------
+
+c   variables dynamiques
+      REAL vcov(ijb_v:ije_v,llm),ucov(ijb_u:ije_u,llm) ! vents covariants
+      REAL teta(ijb_u:ije_u,llm)                 ! temperature potentielle
+      REAL ps(ijb_u:ije_u)                       ! pression  au sol
+      REAL masse(ijb_u:ije_u,llm)                ! masse d'air
+      REAL phis(ijb_u:ije_u)                     ! geopotentiel au sol
+
+c   Local:
+c   ------
+
+      real,allocatable :: ucov_glo(:,:)
+      real,allocatable :: vcov_glo(:,:)
+      real,allocatable :: teta_glo(:,:)
+      real,allocatable :: masse_glo(:,:)
+      real,allocatable :: ps_glo(:)
+
+!      REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
+!      REAL pks(ip1jmp1)                      ! exner au  sol
+!      REAL pk(ip1jmp1,llm)                   ! exner au milieu des couches
+!      REAL pkf(ip1jmp1,llm)                  ! exner filt.au milieu des couches
+!      REAL alpha(ip1jmp1,llm),beta(ip1jmp1,llm)
+
+      real,allocatable :: p(:,:)
+      real,allocatable :: pks(:)
+      real,allocatable :: pk(:,:)
+      real,allocatable :: pkf(:,:)
+      real,allocatable :: alpha(:,:),beta(:,:)
+
+      REAL :: sinth,costh,costh2, Ath,Bth,Cth, lon,dps
+      INTEGER i,j,ij
+
+      REAL, PARAMETER    :: rho=1 ! masse volumique de l'air (arbitraire)
+      REAL, PARAMETER    :: K    = 7.848e-6  ! K = \omega
+      REAL, PARAMETER    :: gh0  = 9.80616 * 8e3 
+      INTEGER, PARAMETER :: R0=4, R1=R0+1, R2=R0+2         ! mode 4
+c NB : rad = 6371220 dans W91 (6371229 dans LMDZ)
+c      omeg = 7.292e-5 dans W91 (7.2722e-5 dans LMDZ)
+
+
+       ! allocate (global) arrays
+       allocate(vcov_glo(ip1jm,llm))
+       allocate(ucov_glo(ip1jmp1,llm))
+       allocate(teta_glo(ip1jmp1,llm))
+       allocate(ps_glo(ip1jmp1))
+       allocate(masse_glo(ip1jmp1,llm))
+
+       allocate(p(ip1jmp1,llmp1))
+       allocate(pks(ip1jmp1))
+       allocate(pk(ip1jmp1,llm))
+       allocate(pkf(ip1jmp1,llm))
+       allocate(alpha(ip1jmp1,llm))
+       allocate(beta(ip1jmp1,llm))
+ 
+      IF(0==0) THEN
+!c Williamson et al. (1991) : onde de Rossby-Haurwitz
+         teta_glo(:,:) = preff/rho/cpp
+!c geopotentiel (pression de surface)
+         do j=1,jjp1
+            costh2 = cos(rlatu(j))**2
+            Ath = (R0+1)*(costh2**2) + (2*R0*R0-R0-2)*costh2 - 2*R0*R0
+            Ath = .25*(K**2)*(costh2**(R0-1))*Ath
+            Ath = .5*K*(2*omeg+K)*costh2 + Ath 
+            Bth = (R1*R1+1)-R1*R1*costh2
+            Bth = 2*(omeg+K)*K/(R1*R2) * (costh2**(R0/2))*Bth
+            Cth = R1*costh2 - R2
+            Cth = .25*K*K*(costh2**R0)*Cth
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               lon = rlonv(i)
+               dps = Ath + Bth*cos(R0*lon) + Cth*cos(2*R0*lon)
+               ps_glo(ij) = rho*(gh0 + (rad**2)*dps)
+            enddo
+         enddo
+!         write(lunout,*) 'W91 ps', MAXVAL(ps), MINVAL(ps)
+c vitesse zonale ucov
+         do j=1,jjp1
+            costh  = cos(rlatu(j))
+            costh2 = costh**2
+            Ath = rad*K*costh
+            Bth = R0*(1-costh2)-costh2
+            Bth = rad*K*Bth*(costh**(R0-1))
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               lon = rlonu(i)
+               ucov_glo(ij,1) = (Ath + Bth*cos(R0*lon))
+            enddo
+         enddo
+!         write(lunout,*) 'W91 u', MAXVAL(ucov(:,1)), MINVAL(ucov(:,1))
+         ucov_glo(:,1)=ucov_glo(:,1)*cu
+c vitesse meridienne vcov
+         do j=1,jjm
+            sinth  = sin(rlatv(j))
+            costh  = cos(rlatv(j))
+            Ath = -rad*K*R0*sinth*(costh**(R0-1))
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               lon = rlonv(i)
+               vcov_glo(ij,1) = Ath*sin(R0*lon)
+            enddo
+         enddo
+         write(lunout,*) 'W91 v', MAXVAL(vcov(:,1)), MINVAL(vcov(:,1))
+         vcov_glo(:,1)=vcov_glo(:,1)*cv
+        
+c         ucov_glo=0
+c         vcov_glo=0
+      ELSE
+c test non-tournant, onde se propageant en latitude
+         do j=1,jjp1
+            do i=1,iip1
+               ij=(j-1)*iip1+i
+               ps_glo(ij) = 1e5*(1 + .1*exp(-100*(1+sin(rlatu(j)))**2))
+            enddo
+         enddo
+         
+c     rho = preff/(cpp*teta)
+         teta_glo(:,:) = .01*preff/cpp   ! rho = 100 ; phi = ps/rho = 1e3 ; c=30 m/s = 2600 km/j = 23 degres / j
+         ucov_glo(:,:)=0.
+         vcov_glo(:,:)=0.
+      END IF      
+      
+      CALL pression ( ip1jmp1, ap, bp, ps_glo, p       )
+      CALL massdair(p,masse_glo)
+
+      ! copy data from global array to local array:
+      teta(ijb_u:ije_u,:)=teta_glo(ijb_u:ije_u,:)
+      ucov(ijb_u:ije_u,:)=ucov_glo(ijb_u:ije_u,:)
+      vcov(ijb_v:ije_v,:)=vcov_glo(ijb_v:ije_v,:)
+      masse(ijb_u:ije_u,:)=masse_glo(ijb_u:ije_u,:)
+      ps(ijb_u:ije_u)=ps_glo(ijb_u:ije_u)
+
+      ! cleanup
+      deallocate(teta_glo)
+      deallocate(ucov_glo)
+      deallocate(vcov_glo)
+      deallocate(masse_glo)
+      deallocate(ps_glo)
+      deallocate(p)
+      deallocate(pks)
+      deallocate(pk)
+      deallocate(pkf)
+      deallocate(alpha)
+      deallocate(beta)
+
+      END
+c-----------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/dyn3dmem/temps.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/temps.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/temps.h	(revision 1795)
@@ -13,11 +13,11 @@
 ! INCLUDE 'temps.h'
 
-      COMMON/temps/itaufin, dt, day_ini, day_end, annee_ref, day_ref,   &
-     &             itau_dyn, itau_phy, jD_ref, jH_ref, calend,          &
-     &             start_time
+      COMMON/temps/ dt, jD_ref, jH_ref, start_time,                     &
+     &             day_ini, day_end, annee_ref, day_ref,                &
+     &             itau_dyn, itau_phy, itaufin, calend
 
 
       INTEGER   itaufin
-      INTEGER itau_dyn, itau_phy
+      INTEGER itau_dyn, itau_phy 
       INTEGER day_ini, day_end, annee_ref, day_ref
       REAL      dt, jD_ref, jH_ref, start_time
Index: LMDZ5/branches/testing/libf/dyn3dmem/top_bound_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/top_bound_loc.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dmem/top_bound_loc.F	(revision 1795)
@@ -1,3 +1,6 @@
-      SUBROUTINE top_bound_loc( vcov,ucov,teta,masse, du,dv,dh )
+!
+! $Id: $
+!
+      SUBROUTINE top_bound_loc(vcov,ucov,teta,masse,dt)
       USE parallel
       IMPLICIT NONE
@@ -25,18 +28,42 @@
 c
 c=======================================================================
-c-----------------------------------------------------------------------
-c   Declarations:
-c   -------------
+
+! top_bound sponge layer model:
+! Quenching is modeled as: A(t)=Am+A0*exp(-lambda*t)
+! where Am is the zonal average of the field (or zero), and lambda the inverse
+! of the characteristic quenching/relaxation time scale
+! Thus, assuming Am to be time-independent, field at time t+dt is given by:
+! A(t+dt)=A(t)-(A(t)-Am)*(1-exp(-lambda*t))
+! Moreover lambda can be a function of model level (see below), and relaxation
+! can be toward the average zonal field or just zero (see below).
+
+! NB: top_bound sponge is only called from leapfrog if ok_strato=.true.
+
+! sponge parameters: (loaded/set in conf_gcm.F ; stored in comconst.h)
+!    iflag_top_bound=0 for no sponge
+!    iflag_top_bound=1 for sponge over 4 topmost layers
+!    iflag_top_bound=2 for sponge from top to ~1% of top layer pressure
+!    mode_top_bound=0: no relaxation
+!    mode_top_bound=1: u and v relax towards 0
+!    mode_top_bound=2: u and v relax towards their zonal mean
+!    mode_top_bound=3: u,v and pot. temp. relax towards their zonal mean
+!    tau_top_bound : inverse of charactericstic relaxation time scale at
+!                       the topmost layer (Hz)
+
 
 #include "comdissipn.h"
+#include "iniprint.h"
 
 c   Arguments:
 c   ----------
 
-      REAL ucov(iip1,jjb_u:jje_u,llm),vcov(iip1,jjb_v:jje_v,llm)
-      REAL teta(iip1,jjb_u:jje_u,llm)
-      REAL masse(iip1,jjb_u:jje_u,llm)
-      REAL dv(iip1,jjb_v:jje_v,llm),du(iip1,jjb_u:jje_u,llm)
-      REAL dh(iip1,jjb_u:jje_u,llm)
+      real,intent(inout) :: ucov(iip1,jjb_u:jje_u,llm) ! covariant zonal wind
+      real,intent(inout) :: vcov(iip1,jjb_v:jje_v,llm) ! covariant meridional wind
+      real,intent(inout) :: teta(iip1,jjb_u:jje_u,llm) ! potential temperature
+      real,intent(in) :: masse(iip1,jjb_u:jje_u,llm) ! mass of atmosphere 
+      real,intent(in) :: dt ! time step (s) of sponge model
+
+!      REAL dv(iip1,jjb_v:jje_v,llm),du(iip1,jjb_u:jje_u,llm)
+!      REAL dh(iip1,jjb_u:jje_u,llm)
 
 c   Local:
@@ -47,9 +74,7 @@
       REAL tzon(jjb_u:jje_u,llm)
       
-      INTEGER NDAMP
-      PARAMETER (NDAMP=4)
       integer i	
       REAL,SAVE :: rdamp(llm)
-!     &   (/(0., i =1,llm-NDAMP),0.125E-5,.25E-5,.5E-5,1.E-5/) 
+      real,save :: lambda(llm) ! inverse or quenching time scale (Hz)
       LOGICAL,SAVE :: first=.true.
       INTEGER j,l,jjb,jje
@@ -57,43 +82,57 @@
 
       if (iflag_top_bound == 0) return
+
       if (first) then
 c$OMP BARRIER
 c$OMP MASTER
          if (iflag_top_bound == 1) then
-! couche eponge dans les 4 dernieres couches du modele
-             rdamp(:)=0.
-             rdamp(llm)=tau_top_bound
-             rdamp(llm-1)=tau_top_bound/2.
-             rdamp(llm-2)=tau_top_bound/4.
-             rdamp(llm-3)=tau_top_bound/8.
+! sponge quenching over the topmost 4 atmospheric layers
+             lambda(:)=0.
+             lambda(llm)=tau_top_bound
+             lambda(llm-1)=tau_top_bound/2.
+             lambda(llm-2)=tau_top_bound/4.
+             lambda(llm-3)=tau_top_bound/8.
          else if (iflag_top_bound == 2) then
-! couce eponge dans toutes les couches de pression plus faible que
-! 100 fois la pression de la derniere couche
-             rdamp(:)=tau_top_bound
+! sponge quenching over topmost layers down to pressures which are
+! higher than 100 times the topmost layer pressure
+             lambda(:)=tau_top_bound
      s       *max(presnivs(llm)/presnivs(:)-0.01,0.)
          endif
+
+! quenching coefficient rdamp(:)
+!         rdamp(:)=dt*lambda(:) ! Explicit Euler approx.
+         rdamp(:)=1.-exp(-lambda(:)*dt)
+
+         write(lunout,*)'TOP_BOUND mode',mode_top_bound
+         write(lunout,*)'Sponge layer coefficients'
+         write(lunout,*)'p (Pa)  z(km)  tau(s)   1./tau (Hz)'
+         do l=1,llm
+           if (rdamp(l).ne.0.) then
+             write(lunout,'(6(1pe12.4,1x))')
+     &        presnivs(l),log(preff/presnivs(l))*scaleheight,
+     &           1./lambda(l),lambda(l)
+           endif
+         enddo
          first=.false.
-         print*,'TOP_BOUND rdamp=',rdamp
 c$OMP END MASTER
 c$OMP BARRIER
-      endif
+      endif ! of if (first)
 
 
       CALL massbar_loc(masse,massebx,masseby)
-C  CALCUL DES CHAMPS EN MOYENNE ZONALE:
-
-      jjb=jj_begin
-      jje=jj_end
-      IF (pole_sud) jje=jj_end-1
-
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
-      do l=1,llm
+
+      ! compute zonal average of vcov (or set it to zero)
+      if (mode_top_bound.ge.2) then
+       jjb=jj_begin
+       jje=jj_end
+       IF (pole_sud) jje=jj_end-1
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+       do l=1,llm
         do j=jjb,jje
           zm=0.
           vzon(j,l)=0
           do i=1,iim
-! Rm: on peut travailler directement avec la moyenne zonale de vcov
-! plutot qu'avec celle de v car le coefficient cv qui relie les deux
-! ne varie qu'en latitude
+! NB: we can work using vcov zonal mean rather than v since the
+! cv coefficient (which relates the two) only varies with latitudes 
             vzon(j,l)=vzon(j,l)+vcov(i,j,l)*masseby(i,j,l)
             zm=zm+masseby(i,j,l)
@@ -101,24 +140,22 @@
           vzon(j,l)=vzon(j,l)/zm
         enddo
-      enddo
+       enddo
 c$OMP END DO NOWAIT   
-
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
-      do l=1,llm
-        do j=jjb,jje
-          do i=1,iip1
-            dv(i,j,l)=dv(i,j,l)-rdamp(l)*(vcov(i,j,l)-vzon(j,l))
-          enddo
-        enddo
-      enddo
-c$OMP END DO NOWAIT
-
-      jjb=jj_begin
-      jje=jj_end
-      IF (pole_nord) jjb=jj_begin+1
-      IF (pole_sud)  jje=jj_end-1
-
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
-      do l=1,llm
+      else
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+       do l=1,llm
+         vzon(:,l)=0.
+       enddo
+c$OMP END DO NOWAIT
+      endif ! of if (mode_top_bound.ge.2)
+
+      ! compute zonal average of u (or set it to zero)
+      if (mode_top_bound.ge.2) then
+       jjb=jj_begin
+       jje=jj_end
+       IF (pole_nord) jjb=jj_begin+1
+       IF (pole_sud)  jje=jj_end-1
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+       do l=1,llm
         do j=jjb,jje
           uzon(j,l)=0.
@@ -130,9 +167,22 @@
           uzon(j,l)=uzon(j,l)/zm
         enddo
-      enddo
-c$OMP END DO NOWAIT
-
+       enddo
+c$OMP END DO NOWAIT
+      else
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+       do l=1,llm
+         uzon(:,l)=0.
+       enddo
+c$OMP END DO NOWAIT
+      endif ! of if (mode_top_bound.ge.2)
+
+      ! compute zonal average of potential temperature, if necessary
+      if (mode_top_bound.ge.3) then
+       jjb=jj_begin
+       jje=jj_end
+       IF (pole_nord) jjb=jj_begin+1
+       IF (pole_sud)  jje=jj_end-1
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)   
-      do l=1,llm
+       do l=1,llm
         do j=jjb,jje
           zm=0.
@@ -144,22 +194,61 @@
           tzon(j,l)=tzon(j,l)/zm
         enddo
-      enddo
-c$OMP END DO NOWAIT
-
-C   AMORTISSEMENTS LINEAIRES:
-
-c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
-      do l=1,llm
+       enddo
+c$OMP END DO NOWAIT
+      endif ! of if (mode_top_bound.ge.3)
+
+      if (mode_top_bound.ge.1) then
+       ! Apply sponge quenching on vcov:
+       jjb=jj_begin
+       jje=jj_end
+       IF (pole_sud) jje=jj_end-1
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+       do l=1,llm
         do j=jjb,jje
           do i=1,iip1
-            du(i,j,l)=du(i,j,l)
-     s               -rdamp(l)*(ucov(i,j,l)-cu(i,j)*uzon(j,l))
-            dh(i,j,l)=dh(i,j,l)-rdamp(l)*(teta(i,j,l)-tzon(j,l))
-          enddo
-       enddo
-      enddo
-c$OMP END DO NOWAIT
-      
-
-      RETURN
+            vcov(i,j,l)=vcov(i,j,l)
+     &                  -rdamp(l)*(vcov(i,j,l)-vzon(j,l))
+          enddo
+        enddo
+       enddo
+c$OMP END DO NOWAIT
+
+       ! Apply sponge quenching on ucov:
+       jjb=jj_begin
+       jje=jj_end
+       IF (pole_nord) jjb=jj_begin+1
+       IF (pole_sud)  jje=jj_end-1
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+       do l=1,llm
+        do j=jjb,jje
+          do i=1,iip1
+            ucov(i,j,l)=ucov(i,j,l)
+     &                  -rdamp(l)*(ucov(i,j,l)-cu(i,j)*uzon(j,l))
+          enddo
+       enddo
+       enddo
+c$OMP END DO NOWAIT
+      endif ! of if (mode_top_bound.ge.1)
+
+      if (mode_top_bound.ge.3) then   
+       ! Apply sponge quenching on teta:
+       jjb=jj_begin
+       jje=jj_end
+       IF (pole_nord) jjb=jj_begin+1
+       IF (pole_sud)  jje=jj_end-1
+
+c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+       do l=1,llm
+        do j=jjb,jje
+          do i=1,iip1
+            teta(i,j,l)=teta(i,j,l)
+     &                  -rdamp(l)*(teta(i,j,l)-tzon(j,l))
+          enddo
+       enddo
+       enddo
+c$OMP END DO NOWAIT
+      endif ! of if (mode_top_bond.ge.3)
+
       END
Index: LMDZ5/branches/testing/libf/dyn3dpar/abort_gcm.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/abort_gcm.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dpar/abort_gcm.F	(revision 1795)
@@ -24,5 +24,5 @@
 
       character(len=*) modname
-      integer ierr
+      integer ierr, ierror_mpi
       character(len=*) message
 
@@ -47,5 +47,11 @@
       else
         write(lunout,*) 'Houston, we have a problem ', ierr
+#ifdef CPP_MPI
+C$OMP CRITICAL (MPI_ABORT_GCM)
+        call MPI_ABORT(COMM_LMDZ, 1, ierror_mpi)
+C$OMP END CRITICAL (MPI_ABORT_GCM)
+#else
         stop 1
+#endif          
       endif
       END
Index: LMDZ5/branches/testing/libf/dyn3dpar/ce0l.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/ce0l.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dpar/ce0l.F90	(revision 1795)
@@ -23,4 +23,5 @@
   USE infotrac
   USE parallel, ONLY: finalize_parallel
+  USE indice_sol_mod
 
 #ifdef CPP_IOIPSL
@@ -39,5 +40,5 @@
 #include "dimensions.h"
 #include "paramet.h"
-#include "indicesol.h"
+!#include "indicesol.h"
 #include "iniprint.h"
 #include "temps.h"
Index: LMDZ5/branches/testing/libf/dyn3dpar/comconst.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/comconst.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dpar/comconst.h	(revision 1795)
@@ -6,5 +6,5 @@
 
       COMMON/comconsti/im,jm,lllm,imp1,jmp1,lllmm1,lllmp1,lcl,          &
-     &                 iflag_top_bound
+     &                 iflag_top_bound,mode_top_bound
       COMMON/comconstr/dtvr,daysec,                                     &
      & pi,dtphys,dtdiss,rad,r,cpp,kappa,cotot,unsim,g,omeg              &
@@ -30,6 +30,8 @@
       REAL omeg ! (rad/s) rotation rate of the planet
       REAL dissip_factz,dissip_deltaz,dissip_zref
-      INTEGER iflag_top_bound
-      REAL tau_top_bound
+! top_bound sponge:
+      INTEGER iflag_top_bound ! sponge type
+      INTEGER mode_top_bound  ! sponge mode
+      REAL tau_top_bound ! inverse of sponge characteristic time scale (Hz)
       REAL daylen ! length of solar day, in 'standard' day length
       REAL year_day ! Number of standard days in a year
Index: LMDZ5/branches/testing/libf/dyn3dpar/comvert.h
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dpar/comvert.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/dyn3dpar/comvert.h	(revision 1795)
@@ -23,5 +23,6 @@
       real bps    ! hybrid sigma contribution at mid-layers
       real scaleheight ! atmospheric (reference) scale height (km)
-      real pseudoalt ! for planets
+      real pseudoalt ! pseudo-altitude of model levels (km), based on presnivs(),
+                     ! preff and scaleheight
 
       integer disvert_type ! type of vertical discretization:
